<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
        />

        <q-toolbar-title>
          <img class="navbarIco" src="icons/logo_gps.svg" alt="logo de gnu personal stats">
          GPS App
        </q-toolbar-title>

        <div>Quasar v{{ $q.version }}</div>

        <q-btn
          flat
          dense
          round
          icon="nightlight"
          aria-label="light/dark"
          @click="toggleDark"
        />
        <q-btn
          v-if="loggedIn === true"
          flat
          dense
          round
          icon="logout"
          aria-label="deconnexion"
          @click="logout"
        />
      </q-toolbar>
    </q-header>

    <q-drawer v-model="leftDrawerOpen" show-if-above bordered>
      <q-list>
        <q-item-label header> Internal Links </q-item-label>

        <EssentialLink
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
        <!-- External Links
        <ExternalLink
          v-for="link in externalLinks"
          :key="link.title"
          v-bind="link"
        /> -->
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { computed, defineComponent, ref } from 'vue';
import EssentialLink from 'components/EssentialLink.vue';
// import ExternalLink from 'components/ExternalLink.vue';
import { useQuasar } from 'quasar';
import { useRouter } from 'vue-router';
import { useAuthStore } from 'src/stores/authStore.js';

const linksList = [
  {
    title: 'Home',
    caption: 'quasar.dev',
    icon: 'home',
    link: '/',
  },
  {
    title: 'À propos',
    caption: 'en savoir plus sur l’application GPS',
    icon: 'help',
    link: '/apropos',
  },
  {
    title: 'account',
    caption: 'the account page',
    icon: 'person',
    link: '/account/',
  },
];
const linksListExtern = [
  {
    title: 'Quasar Documentation',
    caption: 'quasar.dev',
    icon: 'school',
    link: 'https://quasar.dev',
  },
];

export default defineComponent({
  name: 'MainLayout',

  components: {
    EssentialLink,
    // ExternalLink,
  },

  setup() {
    const $q = useQuasar();
    const leftDrawerOpen = ref(false);
    const router = useRouter();
    const authStore = useAuthStore();
    const loggedIn = computed(() => authStore.loggedIn);
    return {
      essentialLinks: linksList,
      externalLinks: linksListExtern,
      leftDrawerOpen,
      loggedIn,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value;
      },
      toggleDark() {
        $q.dark.toggle();
      },
      logout() {
        router.push('/');
        authStore.logout();
      },
    };
  },
});
</script>
<style scoped>
  .navbarIco{
    height: 2rem;
    position: relative;
    top: 8px;
    margin-right: 0.5rem;
  }
</style>
